##!/usr/bin/perl
#
# Schpati - Pre-Alpha of AndyChat v3.xx
# MODULE: Protocols
#
# 29th of April, 2000
# - (11.30pm) Added 'strict' flag to whichcontrol
#
# 28th of April, 2000
# - Moved IRC functions into seperate thing
#

sub whichcontrol {
  my ($self, $protocol, $channel, $strict) = @_;

  if ($window[$thiswin]{protocol} && $window[$thiswin]{protocol} eq $protocol && $window[$thiswin]{control} && $self eq $window[$thiswin]{control})
  {
    if (! $channel || ($window[$thiswin]{channel} && uc($window[$thiswin]{channel}) eq uc($channel)) || ($window[$thiswin]{query} && uc($window[$thiswin]{query}) eq uc($channel)))
    {
      $whichwin = $thiswin;
      return $thiswin;
    }
  }

  for ($ap_i = 1; $ap_i <= $windowcount; $ap_i++)
  {
    if ($window[$ap_i]{protocol} && $window[$ap_i]{protocol} eq $protocol && $window[$ap_i]{control} && $self eq $window[$ap_i]{control})
    {
      if (! $channel || ($window[$ap_i]{channel} && uc($window[$ap_i]{channel}) eq uc($channel)) || ($window[$ap_i]{query} && uc($window[$ap_i]{query}) eq uc($channel)))
      {
        $whichwin = $ap_i;
        return $ap_i;
      }
    }
  }

  if ($strict)
  {
    $whichwin = "";
    return;
  }
  else
  {
    $whichwin = $thiswin;
    return $thiswin;
  }
}

sub foreachcontrol {
  my ($self, $protocol, $todo) = @_;

  for ($ap_z = 1; $ap_z <= $windowcount; $ap_z++)
  {
    if ($window[$ap_z]{protocol} && $window[$ap_z]{protocol} eq $protocol && $window[$ap_z]{control} && $self eq $window[$ap_z]{control})
    {
      &{$todo}($ap_z, $self);
    }
  }
}

# Load IRC module :-)

do 'a_protocols_irc.pl';

# Load ICQ module :-)

do 'a_protocols_icq.pl';

# Load Licq-parser module :-)

do 'a_protocols_licq-parser.pl';

# Load Club Gabbay module :-)

do 'a_protocols_web_clubgabbay.pl';

#
# - = Not Started
# ? = Started
# * = Working
# ! = Finished
#
# Chat Protocols:
#
# 1 - AndyChat (void)
# 2 - IRC *
# 3 - ICQ ?
#     a - Raw ICQ -
#     b - Licq plugin -
#     c - Licq dodgy ?
# 4 - AIM -
# 5 - Yahoo! Pager -
# 6 - MSN Messenger -
#
# Non-mainstream Chat Protocols:
#
# 11 - iChat Pager -
# 12 - Goofey -
# 13 - ICB/FNET -
#
# Proprietry Chat Protocols:
#
# 30 - ichat(?) Java for Channel [V] -
# 31 - Yahoo! Chat -
# 32 - Club Gabbay ?
#
# Game/Other Protocols:
#
# 80 - Tetrinet -
# 81 - Napster -
# 82 - Gnutella -
#
# Multi-protocol:
#
# 90 - Jabber -
#
